# zone-h.tcl v1.0 by domsen <domsen@domsen.org> (c)2oo3
#
# plz mail me or visit my homepage @ www.domsen.org
# also check www.uid-zero.de
#
# everytime when there is a new deface at  www.zone-h.com the script  will post
# the headline  plus the link  into the channel.  its also possible  to get the
# last x defacemment by public or message command.
#
# v1.0 - first public version
#
# zonetrigger - the trigger the bot responds to (public und message)
# zonelimit - the maximum number of lines the bot posts when triggered 
# zonenewspost  - 1 for newsposting, 0 for none
# zonechans  - the chans the script is active in, "" for all
# zonenewspostlimit - the maximum number of lines the bot newsposts
# zonedehub  - 1 enables the hub feature, 0 disables is
# zoneleafs  - the nicks of the leafbots
#
####### config ######################

set zonetrigger ".zone"
set zonechans ""
set zonelimit "5"
set zonenewspostlimit "3"
set zonenewspost "1"
set iszonehub "0"
set zoneleafs ""

####### ende of config ##############

bind msg - $zonetrigger msg_zone
bind pub - $zonetrigger pub_zone
bind time - "?0 * * * *" zonecheck

proc sendzonenews { arg } {
global zoneleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $zoneleafs] [string tolower $bot]] != -1)} {
putbot $bot "zone: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }

proc zonenews { target limit } {
if {[catch {set sock [socket www.zone-h.org 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /en/defacements HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.zone-h.org"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "filter_defacer=" $bl] != -1 } { set defacer [string range $bl [shrink + 3 "/\">" 0 $bl] [shrink - 1 "</a>" 0 $bl]] }
if {[string first "class=\"redlink\" target=\"_blank\"" $bl] != -1 && [string first "mirror" $bl] == -1} {
set page  [string range $bl [expr [string last "\">" $bl] + 2] [shrink - 1 "</a>" 0 $bl]]
}
if {[string first "Win 2000" $bl] != -1} { set os "win 2000" }
if {[string first "Solaris/SunOS" $bl] != -1} { set os "solaris/sunos" }
if {[string first "Linux " $bl] != -1} { set os "linux" }
if {[string first "FreeBSD" $bl] != -1} { set os "freebsd" }
if {[string first "Win NT/9x" $bl] != -1} { set os "win nt/9x" }
if {[string first "AIX" $bl] != -1} { set os "aix" }
if {[string first "BSD/OS" $bl] != -1} { set os "bsd/os" }
if {[string first "BSDI" $bl] != -1} { set os "bsdi" }
if {[string first "Digital UNIX" $bl] != -1} { set os "digital unix" }
if {[string first "IRIX" $bl] != -1} { set os "irix" }
if {[string first "MacOS" $bl] != -1} { set os "macos" }
if {[string first "MacOSX" $bl] != -1} { set os "macos x" }
if {[string first "NetBSD" $bl] != -1} { set os "netbsd" }
if {[string first "NetBSD/OpenBSD" $bl] != -1} { set os "netbsd/openbsd" }
if {[string first "Novell/Netware" $bl] != -1} { set os "novell/netware" }
if {[string first "NT4/Windows 98" $bl] != -1} { set os "nt4/windows 98" }
if {[string first "OpenBSD" $bl] != -1} { set os "openbsd" }
if {[string first "OS/2" $bl] != -1} { set os "os/2" }
if {[string first "OS/390" $bl] != -1} { set os "os/390" }
if {[string first "SCO Unix" $bl] != -1} { set os "sco unix" }
if {[string first "Solaris" $bl] != -1} { set os "solaris" }
if {[string first "Solaris 8" $bl] != -1} { set os "solaris 8" }
if {[string first "Tru64" $bl] != -1} { set os "tru64" }
if {[string first "Unix" $bl] != -1} { set os "unix" }
if {[string first "class=\"redlink\" target=\"_blank\"" $bl] != -1 && [string first "mirror" $bl] != -1} {
set link "www.zone-h.org/[string range $bl [expr [string last "href=\"" $bl] + 7] [shrink - 1 "\">mirror" 0 $bl]]"
set newsline "$page ($os) defaced by $defacer"
putserv "privmsg $target :[incr counter] $newsline <$link>"
}
if {$counter == $limit} {close $sock; return 0}
}}}


proc zonecheck {nick uhost hand chan arg} {
global zonechans zonenewspost iszonehub zonenewspostlimit
set counter 0
if {$zonenewspost == 1 } {
putlog "zone: suche nach neuer newsline"
set zonelastnews "none"
if {[file exists zone.hdl]} {
set temp [open "zone.hdl" r]
set zonelastnews "[gets $temp]"
if {$zonelastnews == ""} { set zonelastnews "none" }
close $temp
}
set temp [open "zone.hdl" w+]
if {[catch {set sock [socket www.zone-h.org 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /en/defacements HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.zone-h.org"
puts $sock "Connection: close"
puts $sock ""
flush $sock
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "filter_defacer=" $bl] != -1 } { set defacer [string range $bl [shrink + 3 "/\">" 0 $bl] [shrink - 1 "</a>" 0 $bl]] }
if {[string first "class=\"redlink\" target=\"_blank\"" $bl] != -1 && [string first "mirror" $bl] == -1} {
set target [string range $bl [expr [string last "\">" $bl] + 2] [shrink - 1 "</a>" 0 $bl]]
}
if {[string first "Win 2000" $bl] != -1} { set os "win 2000" }
if {[string first "Solaris/SunOS" $bl] != -1} { set os "solaris/sunos" }
if {[string first "Linux " $bl] != -1} { set os "linux" }
if {[string first "FreeBSD" $bl] != -1} { set os "freebsd" }
if {[string first "Win NT/9x" $bl] != -1} { set os "win nt/9x" }
if {[string first "AIX" $bl] != -1} { set os "aix" }
if {[string first "BSD/OS" $bl] != -1} { set os "bsd/os" }
if {[string first "BSDI" $bl] != -1} { set os "bsdi" }
if {[string first "Digital UNIX" $bl] != -1} { set os "digital unix" }
if {[string first "IRIX" $bl] != -1} { set os "irix" }
if {[string first "MacOS" $bl] != -1} { set os "macos" }
if {[string first "MacOSX" $bl] != -1} { set os "macos x" }
if {[string first "NetBSD" $bl] != -1} { set os "netbsd" }
if {[string first "NetBSD/OpenBSD" $bl] != -1} { set os "netbsd/openbsd" }
if {[string first "Novell/Netware" $bl] != -1} { set os "novell/netware" }
if {[string first "NT4/Windows 98" $bl] != -1} { set os "nt4/windows 98" }
if {[string first "OpenBSD" $bl] != -1} { set os "openbsd" }
if {[string first "OS/2" $bl] != -1} { set os "os/2" }
if {[string first "OS/390" $bl] != -1} { set os "os/390" }
if {[string first "SCO Unix" $bl] != -1} { set os "sco unix" }
if {[string first "Solaris" $bl] != -1} { set os "solaris" }
if {[string first "Solaris 8" $bl] != -1} { set os "solaris 8" }
if {[string first "Tru64" $bl] != -1} { set os "tru64" }
if {[string first "Unix" $bl] != -1} { set os "unix" }
if {[string first "class=\"redlink\" target=\"_blank\"" $bl] != -1 && [string first "mirror" $bl] != -1} {
set link "www.zone-h.org/[string range $bl [expr [string last "href=\"" $bl] + 7] [shrink - 1 "\">mirror" 0 $bl]]"
set newsline "$target ($os) defaced by $defacer"
puts $temp "$newsline <$link>"
}}}
close $sock ; close $temp
if {$zonelastnews == "none" } { putlog "zone: headlinefile created" ; return 0 }
set temp [open "zone.hdl" r]
while { [eof $temp] != 1 } {
set zoneneunews [gets $temp]
if {($zonelastnews == $zoneneunews) || ($counter == $zonenewspostlimit) || ($zoneneunews == "")} { close $temp;return 0 }
incr counter
if { $iszonehub == "1" } { sendzonenews $zoneneunews }
foreach chan [channels] {
if {$zonechans == "" } { putserv "privmsg $chan :(new defacement) $zoneneunews" }
if {$zonechans != "" } {
if {([lsearch -exact [string tolower $zonechans] [string tolower $chan]] != -1) || ($zonechans == "")} {putserv "privmsg $chan :(new defacement) $zoneneunews"}
}
}}}}


proc msg_zone { nick uhost hand arg } { global zonelimit ; zonenews $nick $zonelimit }
proc pub_zone { nick uhost hand chan arg } { global zonechans zonelimit ; if {([lsearch -exact [string tolower $zonechans] [string tolower $chan]] != -1) || ($zonechans == "")} { zonenews $nick $zonelimit }}


putlog "*** zone-h.tcl v1.2 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]
